// sNZVF[_[̓
struct PS_INPUT
{
	float2 TexCoords0      : TEXCOORD0 ;    // eNX`W
	float3 VPosition       : TEXCOORD1 ;    // W( r[ )
	float3 VTan            : TEXCOORD2 ;    // ڐ( r[ )
	float3 VBin            : TEXCOORD3 ;    // ]@( r[ )
	float3 VNormal         : TEXCOORD4 ;    // @( r[ )
} ;

// sNZVF[_[̏o
struct PS_OUTPUT
{
	float4 Color0          : COLOR0 ;
} ;

// }eAp[^
struct MATERIAL
{
	float4 Diffuse ;      // fBt[YJ[
	float4 Specular ;     // XyLJ[
	float4 Power ;        // XyL̋
} ;

// Cgp[^
struct LIGHT
{
	float4 Position ;               // W( r[ )
	float3 Direction ;              // ( r[ )
	float4 Diffuse ;                // fBt[YJ[
	float4 Specular ;               // XyLJ[
	float4 Ambient ;                // ArGgJ[ƃ}eÃArGgJ[Z
	float4 Range_FallOff_AT0_AT1 ;  // x:L  y:X|bgCgpFallOff  z:ɂ錸pp[^O  w:ɂ錸pp[^P
	float4 AT2_SpotP0_SpotP1 ;      // x:ɂ錸pp[^Q  y:X|bgCgpp[^O( cos( Phi / 2.0f ) )  z:X|bgCgpp[^P( 1.0f / ( cos( Theta / 2.0f ) - cos( Phi / 2.0f ) ) )
} ;


// C++ Őݒ肷eNX`萔̒`
sampler  DiffuseMapTexture             : register( s0 ) ;		// fBt[Y}bveNX`
sampler  NormalMapTexture              : register( s1 ) ;		// @}bveNX`
float4   cfAmbient_Emissive            : register( c1 ) ;		// G~bVuJ[ + }eAArGgJ[ * O[oArGgJ[
MATERIAL cfMaterial                    : register( c2 ) ;		// }eAp[^
float4   cfFactorColor                 : register( c5 ) ;		// sx
LIGHT    cfLight[ 3 ]                  : register( c32 ) ;		// Cgp[^


// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT PSOutput ;
	float4 TextureDiffuseColor ;
	float3 V_to_Eye ;
	float3 Normal ;
	float3 VNrm ;
	float3 VTan ;
	float3 VBin ;
	float4 TotalDiffuse ;
	float4 TotalSpecular ;
	float4 SpecularColor ;
	float3 TempF3 ;
	float Temp ;
	float3 lLightTemp ;
	float lLightDistancePow2 ;
	float lLightDirectionCosA ;
	float lLightGen ;
	float3 lLightDir ;
	float DiffuseAngleGen ;

	// ڐE]@E@𐳋K
	VNrm = normalize( PSInput.VNormal );
	VTan = normalize( PSInput.VTan );
	VBin = normalize( PSInput.VBin );

	// _W王_ւ̃xNgڒԂɓe㐳Kĕۑ
	TempF3.x = dot( VTan, -PSInput.VPosition.xyz ) ;
	TempF3.y = dot( VBin, -PSInput.VPosition.xyz ) ;
	TempF3.z = dot( VNrm, -PSInput.VPosition.xyz ) ;
	V_to_Eye = normalize( TempF3 ) ;

	// @ 0`1 ̒l -1.0`1.0 ɕϊ
	Normal = ( tex2D( NormalMapTexture, PSInput.TexCoords0.xy ).rgb - float3( 0.5f, 0.5f, 0.5f ) ) * 2.0f ;

	// fBt[YJ[ƃXyLJ[̒~ϒl
	TotalDiffuse  = float4( 0.0f, 0.0f, 0.0f, 0.0f ) ;
	TotalSpecular = float4( 0.0f, 0.0f, 0.0f, 0.0f ) ;




	// fBNViCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// CgxNǧvZ
	TempF3 = cfLight[ 0 ].Direction ;

	// Cg̃xNgڒnԂɕϊ
	lLightDir.x = dot( VTan, TempF3 ) ;
	lLightDir.y = dot( VBin, TempF3 ) ;
	lLightDir.z = dot( VNrm, TempF3 ) ;

	// fBt[YFvZ

	// DiffuseAngleGen = fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;

	// fBt[YJ[~ϒl += Cg̃fBt[YJ[ * }eÃfBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z 
	TotalDiffuse += cfLight[ 0 ].Diffuse * cfMaterial.Diffuse * DiffuseAngleGen + cfLight[ 0 ].Ambient ;


	// XyLJ[vZ

	// n[txNǧvZ
	TempF3 = normalize( V_to_Eye - lLightDir ) ;

	// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
	Temp = pow( max( 0.0f, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

	// XyLJ[~ϒl += Temp * Cg̃XyLJ[
	TotalSpecular += Temp * cfLight[ 0 ].Specular ;

	// fBNViCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++( I )




	// X|bgCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// CgxNǧvZ
	TempF3 = normalize( PSInput.VPosition.xyz - cfLight[ 1 ].Position.xyz ) ;

	// Cg̃xNgڒnԂɕϊ
	lLightDir.x = dot( VTan, TempF3 ) ;
	lLightDir.y = dot( VBin, TempF3 ) ;
	lLightDir.z = dot( VNrm, TempF3 ) ;


	// EX|bgCglvZ =======================================( Jn )

	// vZ ------------------

	// _ƃCgʒuƂ̋̓߂
	lLightTemp = PSInput.VPosition.xyz - cfLight[ 1 ].Position.xyz ;
	lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

	// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
	lLightGen = 1.0f / ( cfLight[ 1 ].Range_FallOff_AT0_AT1.z + cfLight[ 1 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 1 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

	// --------------------------------


	// X|bgCgvZ --------

	// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
	TempF3.x = dot( VTan, cfLight[ 1 ].Direction ) ;
	TempF3.y = dot( VBin, cfLight[ 1 ].Direction ) ;
	TempF3.z = dot( VNrm, cfLight[ 1 ].Direction ) ;
	lLightDirectionCosA = dot( lLightDir, TempF3 ) ;

	// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
	lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - cfLight[ 1 ].AT2_SpotP0_SpotP1.y, 0.0f ) * cfLight[ 1 ].AT2_SpotP0_SpotP1.z ), cfLight[ 1 ].Range_FallOff_AT0_AT1.y ) ) ;

	// --------------------------------


	// LO猸őɂ鏈
	lLightGen *= step( lLightDistancePow2, cfLight[ 1 ].Range_FallOff_AT0_AT1.x ) ;

	// EX|bgCglvZ =======================================( I )


	// fBt[YFvZ

	// fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;

	// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * }eAfBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
	TotalDiffuse += ( cfLight[ 1 ].Diffuse * cfMaterial.Diffuse * DiffuseAngleGen + cfLight[ 1 ].Ambient ) * lLightGen ;


	// XyLJ[vZ

	// n[txNǧvZ
	TempF3 = normalize( V_to_Eye - lLightDir ) ;

	// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
	Temp = pow( max( 0.0f, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

	// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
	TotalSpecular += Temp * lLightGen.x * cfLight[ 1 ].Specular ;

	// X|bgCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )






	// |CgCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// CgxNǧvZ
	TempF3 = normalize( PSInput.VPosition.xyz - cfLight[ 2 ].Position.xyz ) ;

	// Cg̃xNgڒnԂɕϊ
	lLightDir.x = dot( VTan, TempF3 ) ;
	lLightDir.y = dot( VBin, TempF3 ) ;
	lLightDir.z = dot( VNrm, TempF3 ) ;


	// lvZ =======================================================( Jn )

	// _ƃCgʒuƂ̋̓߂
	lLightTemp = PSInput.VPosition.xyz - cfLight[ 2 ].Position.xyz ;
	lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

	// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
	lLightGen = 1.0f / ( cfLight[ 2 ].Range_FallOff_AT0_AT1.z + cfLight[ 2 ].Range_FallOff_AT0_AT1.w * sqrt( lLightDistancePow2 ) + cfLight[ 2 ].AT2_SpotP0_SpotP1.x * lLightDistancePow2 ) ;

	// LO猸őɂ鏈
	lLightGen *= step( lLightDistancePow2, cfLight[ 2 ].Range_FallOff_AT0_AT1.x ) ;

	// lvZ =======================================================( I )


	// fBt[YFvZ

	// fBt[YpxvZ
	DiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;

	// fBt[YJ[~ϒl += ( Cg̃fBt[YJ[ * }eAfBt[YJ[ * fBt[YJ[px + Cg̃ArGgJ[ƃ}eÃArGgJ[Z  ) * EX|bgCg̊px
	TotalDiffuse += ( cfLight[ 2 ].Diffuse * cfMaterial.Diffuse * DiffuseAngleGen + cfLight[ 2 ].Ambient ) * lLightGen ;


	// XyLJ[vZ

	// n[txNǧvZ
	TempF3 = normalize( V_to_Eye - lLightDir ) ;

	// Temp = pow( max( 0.0f, N * H ), cfMaterial.Power.x )
	Temp = pow( max( 0.0f, dot( Normal, TempF3 ) ), cfMaterial.Power.x ) ;

	// XyLJ[~ϒl += Temp * EX|bgCg̊px * Cg̃XyLJ[
	TotalSpecular += Temp * lLightGen.x * cfLight[ 2 ].Specular ;

	// |CgCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )







	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// TotalDiffuse = CgfBt[YJ[~ϒl + ( }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z )
	TotalDiffuse += cfAmbient_Emissive ;

	// SpecularColor = Cg̃XyLJ[~ϒl * }eÃXyLJ[
	SpecularColor = TotalSpecular * cfMaterial.Specular ;

	// o̓J[ = TotalDiffuse * eNX`J[ + SpecularColor
	TextureDiffuseColor = tex2D( DiffuseMapTexture, PSInput.TexCoords0.xy ) ;
	PSOutput.Color0.rgb = TextureDiffuseColor.rgb * TotalDiffuse.rgb + SpecularColor.rgb ;

	// At@l = eNX`At@ * }eÃfBt[YAt@ * sx
	PSOutput.Color0.a = TextureDiffuseColor.a * cfMaterial.Diffuse.a * cfFactorColor.a ;

	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// o̓p[^Ԃ
	return PSOutput ;
}


